;;;; intarweb-conditions.scm  -*- Scheme -*-
;;;; Kon Lovett, Jul '18
;;;; Kon Lovett, Jun '13

(module intarweb-conditions

(;export
  ;
  http-condition? ;conflict w/ http-client-conditions
  ;
  urlencoded-request-data-limit-exceeded?
  urlencoded-request-data-limit-exceeded-contents
  urlencoded-request-data-limit-exceeded-limit
  ;
  line-limit-exceeded?
  line-limit-exceeded-contents
  line-limit-exceeded-limit
  ;
  header-error?
  header-error-contents
  ;
  header-limit-exceeded?
  header-limit-exceeded-contents
  header-limit-exceeded-limit
  ;
  unknown-protocol-line?
  unknown-protocol-line-line
  ;
  unknown-protocol?
  unknown-protocol-major
  unknown-protocol-minor
  ;
  unknown-code?
  unknown-code-code
  ;
  unknown-status?
  unknown-status-status
  ;
  rfc1123-subparser?
  rfc1123-subparser-value?
  ;
  rfc850-subparser?
  rfc850-subparser-value?
  ;
  asctime-subparser?
  asctime-subparser-value?
  ;
  http-date-subparser?
  http-date-subparser-value?
  ;
  unencoded-header?
  unencoded-header-value?
  ;
  username-with-colon?
  username-with-colon-value?)

(import scheme
  (intarweb-conditions memo))

;;

(define http-condition? (get 'http-condition?))

;;

(define urlencoded-request-data-limit-exceeded? (get 'urlencoded-request-data-limit-exceeded?))

(define urlencoded-request-data-limit-exceeded-contents (get 'urlencoded-request-data-limit-exceeded-contents))

(define urlencoded-request-data-limit-exceeded-limit (get 'urlencoded-request-data-limit-exceeded-limit))

;;

(define line-limit-exceeded? (get 'line-limit-exceeded?))

(define line-limit-exceeded-contents (get 'line-limit-exceeded-contents))

(define line-limit-exceeded-limit (get 'line-limit-exceeded-limit))

;;

(define header-error? (get 'header-error?))

(define header-error-contents (get 'header-error-contents))

;;

(define header-limit-exceeded? (get 'header-limit-exceeded?))

(define header-limit-exceeded-contents (get 'header-limit-exceeded-contents))

(define header-limit-exceeded-limit (get 'header-limit-exceeded-limit))

;;

(define unknown-protocol-line? (get 'unknown-protocol-line?))

(define unknown-protocol-line-line (get 'unknown-protocol-line-line))

;;

(define unknown-protocol? (get 'unknown-protocol?))

(define unknown-protocol-major (get 'unknown-protocol-major))

(define unknown-protocol-minor (get 'unknown-protocol-minor))

;;

(define unknown-code? (get 'unknown-code?))

(define unknown-code-code (get 'unknown-code-code))

;;

(define unknown-status? (get 'unknown-status?))

(define unknown-status-status (get 'unknown-status-status))

;;

(define rfc1123-subparser? (get 'rfc1123-subparser?))

(define rfc1123-subparser-value? (get 'rfc1123-subparser-value?))

;;

(define rfc850-subparser? (get 'rfc850-subparser?))

(define rfc850-subparser-value? (get 'rfc850-subparser-value?))

;;

(define asctime-subparser? (get 'asctime-subparser?))

(define asctime-subparser-value? (get 'asctime-subparser-value?))

;;

(define http-date-subparser? (get 'http-date-subparser?))

(define http-date-subparser-value? (get 'http-date-subparser-value?))

;;

(define unencoded-header? (get 'unencoded-header?))

(define unencoded-header-value? (get 'unencoded-header-value?))

;;

(define username-with-colon? (get 'username-with-colon?))

(define username-with-colon-value? (get 'username-with-colon-value?))

) ;intarweb-conditions
